Bug 1151747 - Review request: onionshare - share files of any size securely and anonymously
Summary: Review request: onionshare - share files of any size securely and anonymously
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert Mayr
QA Contact: Fedora Extras Quality Assurance
URL: https://onionshare.org/
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-10-11 10:23 UTC by pjp
Modified: 2014-11-10 18:30 UTC (History)
2 users (show)

Fixed In Version: onionshare-0.6-5.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-11-01 01:38:35 UTC
robyduck: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description pjp 2014-10-11 10:23:01 UTC
SPEC -> https://pjp.fedorapeople.org/onionshare.spec
SRPM -> https://pjp.fedorapeople.org/onionshare-0.6-1.fc19.src.rpm
Koji build -> http://koji.fedoraproject.org/koji/taskinfo?taskID=7831189

Description:

OnionShare lets you securely and anonymously share files of any size. It works
by starting a web server, making it accessible as a Tor hidden service, and
generating an unguessable URL to access and download files. It doesn't require
setting up a server on the internet somewhere or using a third party
file sharing service. You host files on your own computer and use a Tor
hidden service to make it temporarily accessible over the internet. The other
user just needs to use Tor Browser to download a file from you.

Could someone please review this package?

Comment 1 pjp 2014-10-11 10:24:02 UTC
@Robert: could you please review this one?

Comment 2 Robert Mayr 2014-10-11 13:18:27 UTC
Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.

The source file has a desktop file, please install it properly.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "GPL (v3 or later)", "Unknown or generated". 6 files
     have unknown license. Detailed output of licensecheck in
     /home/robyduck/1151747-onionshare/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python2.7/site-packages/onionshare,
     /usr/lib/python2.7/site-packages/onionshare_gui
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python2.7/site-
     packages/onionshare_gui, /usr/lib/python2.7/site-packages/onionshare
[?]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/applications
     (torbrowser-launcher, filesystem), /usr/share/pixmaps(torbrowser-
     launcher, filesystem)
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).
You use %global to define the same name as %name, why?

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[?]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
     Fix the warnings if possible.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[?]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     https://github.com/micahflee/onionshare/archive/onionshare-0.6.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags

Please fix this, github uses redirects, so your source should be known as v0.6.tar.gz. Add at least a comment or refer to the other solution in the link above.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

Rpmlint
-------
Checking: onionshare-0.6-1.fc20.noarch.rpm
          onionshare-0.6-1.fc20.src.rpm
onionshare.noarch: W: spelling-error %description -l en_US unguessable -> guessable, unsaleable
onionshare.noarch: W: no-manual-page-for-binary onionshare-gui
onionshare.noarch: W: no-manual-page-for-binary onionshare
onionshare.src: W: spelling-error %description -l en_US unguessable -> guessable, unsaleable
onionshare.src: W: invalid-url Source0: https://github.com/micahflee/onionshare/archive/onionshare-0.6.tar.gz HTTP Error 404: Not Found
2 packages and 0 specfiles checked; 0 errors, 5 warnings.

See comment above to fix this.

Rpmlint (installed packages)
----------------------------
# rpmlint onionshare
onionshare.noarch: W: spelling-error %description -l en_US unguessable -> guessable, unsaleable
onionshare.noarch: W: no-manual-page-for-binary onionshare-gui
onionshare.noarch: W: no-manual-page-for-binary onionshare
1 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'

ok

Requires
--------
onionshare (rpmlib, GLIBC filtered):
    /usr/bin/python2
    pyqt4
    python(abi)
    python-flask
    python-stem
    python2

Provides
--------
onionshare:
    application()
    application(onionshare.desktop)
    onionshare

Comment 3 pjp 2014-10-11 18:09:27 UTC
   Hello Robert,

Thank you so much for this review, I appreciate it.

(In reply to Robert Mayr from comment #2)
> [!]: Package consistently uses macros (instead of hard-coded directory names).
> You use %global to define the same name as %name, why?

  Right, it should have been onionshare_gui; It's fixed now.

> Generic:
> [!]: Sources can be downloaded from URI in Source: tag
>      Note: Could not download Source0:
>      https://github.com/micahflee/onionshare/archive/onionshare-0.6.tar.gz
>      See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
> 
> Please fix this, github uses redirects, so your source should be known as
> v0.6.tar.gz. Add at least a comment or refer to the other solution in the
> link above.
>
> onionshare.src: W: invalid-url Source0:
> https://github.com/micahflee/onionshare/archive/onionshare-0.6.tar.gz HTTP
> Error 404: Not Found
> 2 packages and 0 specfiles checked; 0 errors, 5 warnings.
> 
> See comment above to fix this.

  Yep, fixed now.

Please see:
  -> https://pjp.fedorapeople.org/onionshare.spec
  -> https://pjp.fedorapeople.org/onionshare-0.6-2.fc19.src.rpm
  -> http://koji.fedoraproject.org/koji/taskinfo?taskID=7834260


Thank you.

Comment 4 Robert Mayr 2014-10-11 21:38:10 UTC
The source is not ok, and as the guidelines say, you should use the commit in github: http://fedoraproject.org/wiki/Packaging:SourceURL#Github

I'm also not able to find the installation of the desktop file, could you add it?
http://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

I see you're using {_datarootdir}, just use {_datadir}.

Thanks, Robert.

Comment 5 pjp 2014-10-12 10:41:54 UTC
(In reply to Robert Mayr from comment #4)
> The source is not ok, and as the guidelines say, you should use the commit
> in github: http://fedoraproject.org/wiki/Packaging:SourceURL#Github
> http://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage
> I see you're using {_datarootdir}, just use {_datadir}.

  Yep, fixed!

Please see:
  -> https://pjp.fedorapeople.org/onionshare.spec
  -> https://pjp.fedorapeople.org/onionshare-0.6-3.fc19.src.rpm
  -> http://koji.fedoraproject.org/koji/taskinfo?taskID=7839887

Thank you.

Comment 6 Robert Mayr 2014-10-12 13:31:10 UTC
Ok, a few other comments:
1) The guidelines for the github commit contain also a shortcommit instruction. I think it's better to add it.
2) You should use either $RPM_BUILD_ROOT or %{buildroot}, don't mix them up.
3) in the %files section you have %{_datadir}/* - is the package the owner of all the stuff beside it? It's better to define the single directories separately, IMHO.
4) Use valid macros for the name instead of hardcoding
5) Your desktop file has a deprecated "Encoding" instruction in the [Desktop Entry] section. https://developer.gnome.org/desktop-entry-spec/#deprecated-items

Comment 7 pjp 2014-10-13 16:53:51 UTC
   Hello Robert,

(In reply to Robert Mayr from comment #6)
> 1) The guidelines for the github commit contain also a shortcommit
> instruction. I think it's better to add it.

It's not used in the spec file. I think it's used for 'pre-release' packages.[1]

---
  ...If no numeric version is indicated in the code, you may set Version to 0,
and treat the package as a "pre-release" package (and make use of the
%{shortcommit} macro).
---

> 2) You should use either $RPM_BUILD_ROOT or %{buildroot}, don't mix them up.

  Fixed.

> 3) in the %files section you have %{_datadir}/* - is the package the owner
> of all the stuff beside it? It's better to define the single directories
> separately, IMHO.

  done.

> 4) Use valid macros for the name instead of hardcoding

  ...? 
 
> 5) Your desktop file has a deprecated "Encoding" instruction in the [Desktop
> Entry] section.

  Fixed. (I'll let the upstream know about it)


Please see:
  -> https://pjp.fedorapeople.org/onionshare.spec
  -> https://pjp.fedorapeople.org/onionshare-0.6-4.fc19.src.rpm
  -> http://koji.fedoraproject.org/koji/taskinfo?taskID=7851242


Thank you.
---
[1] -> https://fedoraproject.org/wiki/Packaging:SourceURL#Github

Comment 8 Robert Mayr 2014-10-13 18:28:45 UTC
In addition to:
4) onionshare.desktop should better be %{name}.desktop

Thanks.

Comment 9 Robert Mayr 2014-10-13 18:34:23 UTC
Oh, and maybe it's better to put your instruction to get rif of the Encoding key into %prep, before the %build section.

Comment 10 pjp 2014-10-14 05:30:15 UTC
(In reply to Robert Mayr from comment #9)
> Oh, and maybe it's better to put your instruction to get rif of the Encoding
> key into %prep, before the %build section.

  done.

Please see:
  -> https://pjp.fedorapeople.org/onionshare.spec
  -> https://pjp.fedorapeople.org/onionshare-0.6-5.fc19.src.rpm
  -> http://koji.fedoraproject.org/koji/taskinfo?taskID=7857651

Thank you.

Comment 11 Robert Mayr 2014-10-14 09:29:18 UTC
Ok, works for me now!

Comment 12 pjp 2014-10-14 18:23:13 UTC
(In reply to Robert Mayr from comment #11)
> Ok, works for me now!

  Cool! Thanks so much for the review Robert, I appreciate it. Would you like to co-maintain 'onionshare' package with me?

Thank you. :)

Comment 13 Robert Mayr 2014-10-14 18:27:35 UTC
Yes sure!
Thanks

Comment 14 pjp 2014-10-15 06:31:13 UTC
New Package SCM Request
=======================
Package Name: onionshare
Short Description: Securely and anonymously share files of any size
Upstream URL: https://onionshare.org/
Owners: pjp robyduck
Branches: f19 f20 f21 el6 epel7
InitialCC:

Comment 15 Gwyn Ciesla 2014-10-15 10:09:43 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2014-10-15 17:40:51 UTC
onionshare-0.6-5.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/onionshare-0.6-5.fc21

Comment 17 Fedora Update System 2014-10-15 17:40:59 UTC
onionshare-0.6-5.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/onionshare-0.6-5.fc20

Comment 18 Fedora Update System 2014-10-15 17:41:07 UTC
onionshare-0.6-5.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/onionshare-0.6-5.fc19

Comment 19 Fedora Update System 2014-10-15 17:41:15 UTC
onionshare-0.6-5.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/onionshare-0.6-5.el7

Comment 20 Fedora Update System 2014-10-15 17:41:21 UTC
onionshare-0.6-6.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/onionshare-0.6-6.el6

Comment 21 Fedora Update System 2014-10-16 17:17:21 UTC
onionshare-0.6-5.fc21 has been pushed to the Fedora 21 testing repository.

Comment 22 Robert Mayr 2014-10-19 14:07:41 UTC
Updated el6 build to 0.6-7 fixing the name of pyQt4. Probably it needs to be done also for all other builds to be consistent.

Comment 23 Fedora Update System 2014-11-01 01:38:35 UTC
onionshare-0.6-5.fc19 has been pushed to the Fedora 19 stable repository.

Comment 24 Fedora Update System 2014-11-01 01:46:42 UTC
onionshare-0.6-5.fc20 has been pushed to the Fedora 20 stable repository.

Comment 25 Fedora Update System 2014-11-01 17:04:04 UTC
onionshare-0.6-5.fc21 has been pushed to the Fedora 21 stable repository.

Comment 26 Fedora Update System 2014-11-10 18:30:37 UTC
onionshare-0.6-5.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.